#include <iostream>
#include "s7.h"

static s7_pointer main_quit(s7_scheme *sc, s7_pointer args);
static bool is_balanced(std::string str);
static bool is_not_white(std::string str);

int main(int argc, const char* argv[])
{
  s7_scheme* s7 = s7_init();
  s7_pointer val;
  std::string str;

  try 
  {
    while (std::cin)
    {
      std::cout << "\ns7> ";
      str = "";
      while (true)
      {
	std::string lin;
	std::getline(std::cin, lin);
	str = str + lin + "\n";
	if (is_balanced(str))
	  break;
      }
      if (is_not_white(str))
      {
	val = s7_eval_c_string(s7, str.c_str());
	std::cout << s7_object_to_c_string(s7, val);
      }
    }
  }
  catch(...)
  {
  }
  std::cout << "Bye!\n";
  return 0;
}

static s7_pointer main_quit(s7_scheme *sc, s7_pointer args)
{
  throw 0;
  return(s7_nil(sc));
}

static bool is_balanced(std::string str)
{
  int parens = 0;
  int quotes = 0;
  unsigned i = 0;
  while (i < str.size())
  {
    if (str[i] == ';')
    {
      for (i = i + 1; i < str.size(); i++)
      {
	if (str[i] == '\n')
	  break;
      }
    }
    else if (str[i] == '"')
    {
      if (i == 0 || str[i - 1] != '\\')
      {
	quotes = 1;
	for (i = i + 1; i < str.size(); i++)
	{
	  if (str[i] == '"' && str[i - 1] != '\\')
	  {
	    quotes = 0;
	    break;
	  }
	}
	if (quotes)
	  return false;
      }
    }
    else if (str[i] == '(')
      parens++;
    else if (str[i] == ')')
      parens--;
    i++;
  }
  return (parens == 0) && (quotes == 0);
}

static bool is_not_white(std::string str)
{
  for (unsigned i = 0; (i < str.size() && str[i] != ';'); i++)
    if (str[i] != ' ' && str[i] != '\n' && str[i] != '\t')
      return true;
  return false;
}

#if 0
gcc -DHAVE_PREMAKE -I./sndlib -c sndlib/s7.c -o res/bin/s7.o
g++ -I./sndlib -c res/bin/repl.cpp -o res/bin/repl.o
g++ -o res/bin/s7 res/bin/repl.o res/bin/s7.o -ldl
rm res/bin/s7.o res/bin/repl.o
#endif

